
% Frontiers paper PC-DN figure 1 panels A-F

% SUMMARY. Illustration of the number of spikes received by a single nuclear 
% cell each ms across a 200 ms step cycle, with convergence of %:1, 10:1, 20:1 
% and 40:1 (the reported range is 30-50 in mice), with and without taking a 
% rolling mean.

% Create 40 arrays, each of 200 0s and 1s. 'array()' is a function called by 
% the program. Each array represents a PC and each index position represents 
% a ms. At each index position, 'array()' generates either a 1 (with a
% sinusoidally time-varying probability) or else a 0.

PC1 = array(); PC2 = array(); PC3 = array(); PC4 = array();
PC5 = array(); PC6 = array(); PC7 = array(); PC8 = array();
PC9 = array(); PC10 = array(); PC11 = array(); PC12 = array();
PC13 = array(); PC14 = array(); PC15 = array(); PC16 = array();
PC17 = array(); PC18 = array(); PC19 = array(); PC20 = array();
PC21 = array(); PC22 = array(); PC23 = array(); PC24 = array();
PC25 = array(); PC26 = array(); PC27 = array(); PC28 = array();
PC29 = array(); PC30 = array(); PC31 = array(); PC32 = array();
PC33 = array(); PC34 = array(); PC35 = array(); PC36 = array();
PC37 = array(); PC38 = array(); PC39 = array(); PC40 = array();

% Create an array of 200 elements whose first element is the sum of the 
% first elements of arrays 1-5, whose second element is the sum of the
% second elements of arrays 1-5, and so on, so that the new array 
% represents the sum of spikes received by a nuclear cell each ms for 200
% ms

total_spks_5PCs = (PC1 + PC2 + PC3 + PC4 + PC5);

% Ditto for arrays 1-10

total_spks_10PCs = (PC1 + PC2 + PC3 + PC4 + PC5 + PC6...
    + PC7 + PC8 + PC9 + PC10);

% Ditto for arrays 1-20

total_spks_20PCs = (PC1 + PC2 + PC3 + PC4 + PC5 + PC6...
    + PC7 + PC8 + PC9 + PC10 + PC11 + PC12...
    + PC13 + PC14 + PC15 + PC16 + PC17 + PC18...
    + PC19 + PC20); 

% Ditto for arrays 1-40

total_spks_40PCs = (PC1 + PC2 + PC3 + PC4 + PC5 + PC6...
    + PC7 + PC8 + PC9 + PC10 + PC11 + PC12...
    + PC13 + PC14 + PC15 + PC16 + PC17 + PC18...
    + PC19 + PC20 + PC21 + PC22 + PC23 + PC24...
    + PC25 + PC26 + PC27 + PC28 + PC29 + PC30...
    + PC31 + PC32 + PC33 + PC34 + PC35 + PC36...
    + PC37 + PC38 + PC39 + PC40);

% Plots representing the total spikes received by a nuclear cell
% each ms from 10 PCs, from 20, and from 40.

% arrays of spikes/ms at instantaneous rates

fivePCs = ten_ms(0.25,0.275,0.325,0.4,0.5125,0.625,0.7375,0.85,0.925,0.975,1);
tenPCs = ten_ms(0.5,0.55,0.65,0.8,1.025,1.25,1.475,1.7,1.85,1.95,2);
twentyPCs = ten_ms(1,1.1,1.3,1.6,2.05,2.5,2.95,3.4,3.7,3.9,4);
fortyPCs = ten_ms(2,2.2,2.6,3.2,4.1,5,5.9,6.8,7.4,7.8,8);

opengl software

x = 1:1:200;

figure;

subplot(6,4,[1 5])
plot(x,total_spks_5PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,12]);
title('5:1'); ylabel('spikes per ms'); %xlabel('ms');
set(gca,'FontSize',10)
hold on
plot(x,fivePCs,'LineWidth',1,'Color',[.5 0 0])

subplot(6,4,[2 6])
plot(x,total_spks_10PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,12]);
title('10:1'); %ylabel('spikes per ms'); %xlabel('ms');
set(gca,'FontSize',10)
hold on
plot(x,tenPCs,'LineWidth',1,'Color',[.5 0 0])

subplot(6,4,[3 7])
plot(x,total_spks_20PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,12]);
title('20:1'); %ylabel('spikes per ms'); %xlabel('ms');
set(gca,'FontSize',10)
hold on
plot(x,twentyPCs,'LineWidth',1)

subplot(6,4,[4 8])
plot(x,total_spks_40PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,12]);
title('40:1'); %ylabel('spikes per ms'); %xlabel('ms');
set(gca,'FontSize',10)
hold on
plot(x,fortyPCs,'LineWidth',1)

% Plots of a rolling 5 ms average for 10 Pcs, for
% 20 PCs and for 40 PCs

subplot(6,4,[9 13])
combine_5ms_5PCs = integrate_all_intervals(total_spks_5PCs);
plot(x,combine_5ms_5PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,12]);
title(''); xlabel('ms'); ylabel('rolling mean')
set(gca,'FontSize',10)
hold on
plot(x,fivePCs,'LineWidth',1)

subplot(6,4,[10 14])
combine_5ms_10PCs = integrate_all_intervals(total_spks_10PCs);
plot(x,combine_5ms_10PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,12]);
title(''); xlabel('ms'); %ylabel('5 ms rolling average')
set(gca,'FontSize',10)
hold on
plot(x,tenPCs,'LineWidth',1)

subplot(6,4,[11 15])
combine_5ms_20PCs = integrate_all_intervals(total_spks_20PCs);
plot(x,combine_5ms_20PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,12]);
title(''); xlabel('ms')
set(gca,'FontSize',10)
hold on
plot(x,twentyPCs,'LineWidth',1)

subplot(6,4,[12 16])
combine_5ms_40PCs = integrate_all_intervals(total_spks_40PCs);
plot(x,combine_5ms_40PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,12]);
title(''); xlabel('ms')
set(gca,'FontSize',10)
hold on
plot(x,fortyPCs,'LineWidth',1)

% Same data as first four panels but with probability curves aligned

subplot(6,4,[17 21])
plot(x,total_spks_5PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,2]);
title(''); ylabel('spikes per ms'); xlabel('ms');
set(gca,'FontSize',10)
hold on
plot(x,fivePCs,'LineWidth',1,'Color',[.5 0 0])

subplot(6,4,[18 22])
plot(x,total_spks_10PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,4]);
title(''); xlabel('ms');
set(gca,'FontSize',10)
hold on
plot(x,tenPCs,'LineWidth',1,'Color',[.5 0 0])

subplot(6,4,[19 23])
plot(x,total_spks_20PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,8]);
title(''); xlabel('ms');
set(gca,'FontSize',10)
hold on
plot(x,twentyPCs,'LineWidth',1)

subplot(6,4,[20 24])
plot(x,total_spks_40PCs,'o','MarkerSize',2,'Color',[0 0 .5],'MarkerFaceColor',[.8 .8 1]); 
ylim([0,16]);
title(''); xlabel('ms');
set(gca,'FontSize',10)
hold on
plot(x,fortyPCs,'LineWidth',1)

